/*******************************************************************************
 * Copyright (c) 2017 fortiss GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v20.html
 *
 * Contributors:
 *    Florian Hoelzl - initial API and implementation
 *******************************************************************************/
#ifndef INC_CANCATALOG_H_
#define INC_CANCATALOG_H_

#include <stdint.h>

#include "canthread.h"
#include "caninbox.h"

/** Type of catalog entry receivers, which must reclaim the memory of the message after using it. */
typedef void (*can_catalog_receive_handler_t)(can_thread_message_t* message);

/** Initializes the cancatalog sub-system registering it with the canthreadsub-system. */
void can_catalog_initialize(const char* if_name, uint64_t can_thread_sleep_in_micros);

/** Sets name and handler function for the CAN message with the given id. */
void can_catalog_set_entry(uint8_t entry_id, char* signal_name, can_inbox_t* inbox);

/** Returns the catalog entry name for the CAN message with the given id. */
char* can_catalog_entry_name(uint8_t entry_id);

/** Unsets the catalog entry with the given id. */
void can_catalog_unset_entry(uint8_t entry_id);

/** Destroys the cancatalog and frees its resources. */
void can_catalog_destroy();

#endif /* INC_CANCATALOG_H_ */
